function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);

	//LD-8267 - Added a condition to avoid tracking null/empty data unnecessarily
	if (hexString.length > 0 || (myTop.suspendDataCache && myTop.suspendDataCache.indexOf('VarTrivBtnTracking') >= 0) || !this.VarTrivBtnTracking.bSCORM)
		this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'introduction_to_technology_media_and_telecommunications', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:655155,v:'normalState'},{id:47849,v:'normalState'},{id:50838,v:'normalState'},{id:50845,v:'normalState'},{id:50852,v:'normalState'},{id:50859,v:'normalState'},{id:265103,v:'normalState'},{id:52029,v:'normalState'},{id:58646,v:'normalState'},{id:598617,v:'normalState'},{id:176645,v:'normalState'},{id:293612,v:'normalState'},{id:9201,v:'normalState'},{id:9947,v:'normalState'},{id:575907,v:'normalState'},{id:792169,v:'normalState'},{id:792160,v:'normalState'},{id:1049010,v:'normalState'},{id:1049020,v:'normalState'},{id:1049030,v:'normalState'},{id:1049051,v:'normalState'},{id:1049066,v:'normalState'},{id:1049074,v:'normalState'},{id:1049088,v:'normalState'},{id:720758,v:'normalState'},{id:720746,v:'normalState'},{id:720734,v:'normalState'},{id:720722,v:'normalState'},{id:720710,v:'normalState'},{id:720698,v:'normalState'},{id:802069,v:'normalState'},{id:1050161,v:'normalState'},{id:1069453,v:'normalState'},{id:1069707,v:'normalState'},{id:1050133,v:'normalState'},{id:1050144,v:'normalState'},{id:1069716,v:'normalState'},{id:1054330,v:'normalState'},{id:1054345,v:'normalState'},{id:1054360,v:'normalState'},{id:1054374,v:'normalState'},{id:1054288,v:'normalState'},{id:1054297,v:'normalState'},{id:1054306,v:'normalState'},{id:1054315,v:'normalState'},{id:1172866,v:'normalState'},{id:1172910,v:'normalState'},{id:1170133,v:'normalState'},{id:1170142,v:'normalState'},{id:1170151,v:'normalState'},{id:1170160,v:'normalState'},{id:1170173,v:'normalState'},{id:1199189,v:'normalState'},{id:1200234,v:'normalState'},{id:1202400,v:'normalState'},{id:1053606,v:'normalState'},{id:1053615,v:'normalState'},{id:1053624,v:'normalState'},{id:1203545,v:'normalState'},{id:1053639,v:'normalState'},{id:1205277,v:'normalState'},{id:1205430,v:'normalState'},{id:1205642,v:'normalState'},{id:1051868,v:'normalState'},{id:1051909,v:'normalState'},{id:1051921,v:'normalState'},{id:1051933,v:'normalState'},{id:1051945,v:'normalState'},{id:1051986,v:'normalState'},{id:1052086,v:'normalState'},{id:1211871,v:'normalState'},{id:1212093,v:'normalState'},{id:1052132,v:'normalState'},{id:1052141,v:'normalState'},{id:1082246,v:'normalState'},{id:1082258,v:'normalState'},{id:1082270,v:'normalState'},{id:1082282,v:'normalState'},{id:1082299,v:'normalState'},{id:1082322,v:'normalState'},{id:1213597,v:'normalState'},{id:1214146,v:'normalState'},{id:1082366,v:'normalState'},{id:1082375,v:'normalState'},{id:1084137,v:'normalState'},{id:1084149,v:'normalState'},{id:1084161,v:'normalState'},{id:1084173,v:'normalState'},{id:1084190,v:'normalState'},{id:1084213,v:'normalState'},{id:1214772,v:'normalState'},{id:1215354,v:'normalState'},{id:1084257,v:'normalState'},{id:1084266,v:'normalState'},{id:1085105,v:'normalState'},{id:1085117,v:'normalState'},{id:1085129,v:'normalState'},{id:1085141,v:'normalState'},{id:1085158,v:'normalState'},{id:1085181,v:'normalState'},{id:1217917,v:'normalState'},{id:1218218,v:'normalState'},{id:1085225,v:'normalState'},{id:1085234,v:'normalState'},{id:1170449,v:'normalState'},{id:1170463,v:'normalState'},{id:1170483,v:'normalState'},{id:1219342,v:'normalState'},{id:1170691,v:'normalState'},{id:1170705,v:'normalState'},{id:1170725,v:'normalState'},{id:1170741,v:'normalState'},{id:1220359,v:'normalState'},{id:1220373,v:'normalState'},{id:1220391,v:'normalState'},{id:1222023,v:'normalState'},{id:1222287,v:'normalState'},{id:1222301,v:'normalState'},{id:1222319,v:'normalState'},{id:1222333,v:'normalState'},{id:1222495,v:'normalState'},{id:1222509,v:'normalState'},{id:1222527,v:'normalState'},{id:1222541,v:'normalState'},{id:1222792,v:'normalState'},{id:1222806,v:'normalState'},{id:1222824,v:'normalState'},{id:1222838,v:'normalState'},{id:1223032,v:'normalState'},{id:1223046,v:'normalState'},{id:1223064,v:'normalState'},{id:1223078,v:'normalState'},{id:1223877,v:'normalState'},{id:1223891,v:'normalState'},{id:1223909,v:'normalState'},{id:1224139,v:'normalState'},{id:1147134,v:'normalState'},{id:1147157,v:'normalState'},{id:1171073,v:'normalState'},{id:1171117,v:'normalState'},{id:1171606,v:'normalState'},{id:1171619,v:'normalState'},{id:1171632,v:'normalState'},{id:1171645,v:'normalState'},{id:1171658,v:'normalState'},{id:1171675,v:'normalState'},{id:1171700,v:'normalState'},{id:1230172,v:'normalState'},{id:1230394,v:'normalState'},{id:1171751,v:'normalState'},{id:1171761,v:'normalState'},{id:1230661,v:'normalState'},{id:1230674,v:'normalState'},{id:1230687,v:'normalState'},{id:1230700,v:'normalState'},{id:1230713,v:'normalState'},{id:1230730,v:'normalState'},{id:1230754,v:'normalState'},{id:1232293,v:'normalState'},{id:1232786,v:'normalState'},{id:1230804,v:'normalState'},{id:1230814,v:'normalState'},{id:1233166,v:'normalState'},{id:1233179,v:'normalState'},{id:1233192,v:'normalState'},{id:1233205,v:'normalState'},{id:1233218,v:'normalState'},{id:1233235,v:'normalState'},{id:1233259,v:'normalState'},{id:1234285,v:'normalState'},{id:1234431,v:'normalState'},{id:1233308,v:'normalState'},{id:1233318,v:'normalState'},{id:1234861,v:'normalState'},{id:1234874,v:'normalState'},{id:1234887,v:'normalState'},{id:1234900,v:'normalState'},{id:1234913,v:'normalState'},{id:1234930,v:'normalState'},{id:1234954,v:'normalState'},{id:1237034,v:'normalState'},{id:1237272,v:'normalState'},{id:1235004,v:'normalState'},{id:1235014,v:'normalState'},{id:1237580,v:'normalState'},{id:1237593,v:'normalState'},{id:1237606,v:'normalState'},{id:1237619,v:'normalState'},{id:1237632,v:'normalState'},{id:1237649,v:'normalState'},{id:1237673,v:'normalState'},{id:1239809,v:'normalState'},{id:1240021,v:'normalState'},{id:1237722,v:'normalState'},{id:1237732,v:'normalState'},{id:937962,v:'normalState'},{id:1173155,v:'normalState'},{id:1173177,v:'normalState'},{id:1241207,v:'normalState'},{id:939477,v:'normalState'},{id:1256096,v:'normalState'},{id:1173437,v:'normalState'},{id:1173448,v:'normalState'},{id:1173459,v:'normalState'},{id:1256087,v:'normalState'},{id:1243170,v:'normalState'},{id:1245878,v:'normalState'},{id:1246039,v:'normalState'},{id:1248124,v:'normalState'},{id:1173634,v:'normalState'},{id:1173648,v:'normalState'},{id:1173664,v:'normalState'},{id:1173679,v:'normalState'},{id:1173693,v:'normalState'},{id:1173701,v:'normalState'},{id:1173710,v:'normalState'},{id:1173719,v:'normalState'},{id:1173728,v:'normalState'},{id:1173737,v:'normalState'},{id:687477,v:'normalState'},{id:318070,v:'normalState'},{id:70221,v:'normalState'},{id:194542,v:'normalState'},{id:294732,v:'normalState'},{id:1025142,v:'normalState'},{id:1025156,v:'normalState'},{id:1025256,v:'normalState'},{id:1025270,v:'normalState'},{id:321023,v:'normalState'},{id:321015,v:'normalState'},{id:323409,v:'normalState'},{id:323401,v:'normalState'},{id:323733,v:'normalState'},{id:323725,v:'normalState'},{id:1055301,v:'normalState'},{id:1055315,v:'normalState'},{id:788049,v:'normalState'},{id:788063,v:'normalState'},{id:1055430,v:'normalState'},{id:1055444,v:'normalState'},{id:923576,v:'normalState'},{id:923590,v:'normalState'},{id:70100,v:'normalState'},{id:325221,v:'normalState'},{id:325757,v:'normalState'},{id:329044,v:'normalState'},{id:327409,v:'normalState'},{id:625193,v:'normalState'},{id:625135,v:'normalState'},{id:625143,v:'normalState'},{id:625151,v:'normalState'},{id:625159,v:'normalState'},{id:625167,v:'normalState'},{id:233645,v:'normalState'},{id:233637,v:'normalState'},{id:590305,v:'normalState'},{id:590317,v:'normalState'},{id:673002,v:'normalState'},{id:674262,v:'normalState'},{id:590337,v:'normalState'},{id:590345,v:'normalState'},{id:233060,v:'normalState'},{id:233308,v:'normalState'},{id:135253,v:'normalState'},{id:234172,v:'normalState'},{id:233847,v:'normalState'},{id:233839,v:'normalState'},{id:69966,v:'normalState'}]};
